
(*
     P R A U S . P A S

     Routinen fr direkten Video-RAM-Zugriff und Seitenverwaltung;
     ebenfalls enthalten: Druckerausgabe, Text-Abspeicherung.

     DL1BHO, im Juni 1988
*)


unit PRAUS;


interface


uses crt,
     printer,

     PRDEFS,
     PRLIB;

procedure umlaute(var ch: char; umlaut: boolean);
{ folgende 4 procedure von DG6MAY zum SCROLLEN }
procedure scrollpage(Kanal : integer);
procedure scrollline(kanal : integer);
procedure scrollram(y1,y2 : integer);
procedure umschichten;
procedure writePage(Kanal,X_Pos,Y_Pos : integer ; Zeile : str255);
procedure V_aus(Kanal : integer ; Zeile : str255);
procedure write_SaveFile(Kanal : integer ; Zeile : str255);
procedure write_Drucker(Kanal : integer ; Zeile : str255);
procedure _aus(Kanal : integer ; Zeile : str255);
procedure M_aus(Zeile : str255);
procedure _clreol(Kanal : integer);
procedure PageInit;
procedure StatusOut (Kanal,x,Attr:integer ; Zeile:str80);
procedure Cursor(Kanal : integer);  (* Einen blinkenden Cursor setzen *)


implementation


(*
   Bildschirmseiten 0 bis 9 von Zeile Y1 bis Zeile Y2 scrollen
   Bei Kanal = 10 wird nicht das RAM sondern das Bild bearbeitet
*)


procedure umlaute;
begin
 if umlaut then
   case ch of
     #91: ch:='';
     #92: ch:='';
     #93: ch:='';
     #123: ch:='';
     #124: ch:='';
     #125: ch:='';
     #126: ch:='';
   end;
end;


procedure scrollpage;
var i       : integer;
    AMerk   : byte;
Begin
    with K[Kanal]^ do
    Begin
      for i := asl to 25 - 1 do
      Begin
        move(Page[i * 160 + 1],Page[(i - 1) * 160 + 1],160);
      End;
      for i := 0 to 79 do
      Begin
        Page[pred(25) * 160 + succ(i shl 1)] := ' ';
        Page[pred(25) * 160 + i shl 1 + 2] := Chr(low);
      End;
    End;
End;


procedure scrollram;            (* Kanal = 10, also Video-Ram scrollen *)
 var amerk: byte;
  Begin
      AMerk := TextAttr;      TextAttr := low;
      window(1,Y1,80,Y2);
      gotoxy(1,Y2-Y1+1);      writeln;
      window(1,1,80,25);
      TextAttr := AMerk;
  End;


procedure scrollline;
var i       : integer;
    AMerk   : byte;
Begin
    with K[Kanal]^ do
    Begin
      for i := 1 to 2 - 1 do
      Begin
        move(line[i * 160 + 1],line[(i - 1) * 160 + 1],160);
      End;
      for i := 0 to 79 do
      Begin
        line[pred(2) * 160 + succ(i shl 1)] := ' ';
        line[pred(2) * 160 + i shl 1 + 2] := Chr(low);
      End;
    End;
End;

(*
   Zeile auf Schirm und ins RAM schreiben / kein Scrolling
   wird nur zur Ausgabe der ersten Statuszeile benutzt
*)

procedure writePage;
var i         : integer;
    ch        : char;
    Position  : integer;
    aktuell   : boolean;

Begin

  if (Kanal = show) and not ScreenSTBY then aktuell := true else aktuell := false;

  with K[Kanal]^ do
  Begin
    Position := pred(Y_Pos) * 160 + pred(X_Pos shl 1);
    for i := 1 to length(Zeile) do
    Begin
      ch := Zeile[i];
      if aktuell then
      Begin
        Bild[VideoOfs,Position] := ch;
        inc(Position);
        Bild[VideoOfs,Position] := chr(TextAttr);
        Position := pred(Position);
      End;
      line[Position] := ch;
      inc(Position);
      line[Position] := chr(TextAttr);
      inc(Position);
    End;

  End;
End;


(*
   Zeile im Vorschreibschirm ausgeben
*)

procedure V_aus (* Kanal : integer ; Zeile : str255 *);

var i         : integer;
    ch        : char;
    Position  : integer;
    aktuell   : boolean;
    AMerk     : byte;

Begin

  if (Kanal = show) and not ScreenSTBY then aktuell := true else aktuell := false;

  with K[Kanal]^ do
  Begin
    Position := 160 + pred(X1 shl 1);
    for i := 1 to length(Zeile) do
    Begin
      ch := chr(ord(Zeile[i]) and 127);

      umlaute(ch,umlaut);

      case ch of
       ^M  : Begin
               scrollline(Kanal);
               if aktuell then scrollram(1,2);
               X1 := 1;
               Position := 161;
             End;
       ^H  : Begin
               if X1 > 1 then
               Begin
                 X1 := pred(X1);
                 Position := pred(pred(Position));
               End;
             End;
       else  Begin
               AMerk := TextAttr;
               if (ch >= #0) AND (ch <= #31) then
               Begin
                 TextAttr := ctrlAttrib;
                 ch := chr(ord(ch)+64);
               End;
               if aktuell then
               Begin
                 Bild[VideoOfs,Position] := ch;
                 inc(Position);
                 Bild[VideoOfs,Position] := chr(TextAttr);
                 Position := pred(Position);
               End;
               line[Position] := ch;
               inc(Position);
               line[Position] := chr(TextAttr);
               inc(Position);
               inc(X1);
               TextAttr := AMerk;
             End;
      end;

      if X1 > 80 then
      Begin
        scrollline(Kanal);
        if aktuell then scrollram(1,2);
        X1 := 1;
        Position := 161;
      End;

    End;
  End;
End;


(*
   Den String 'Zeile' in das SaveFile von Kanal schreiben
*)

procedure write_SaveFile (* Kanal : integer ; Zeile : str255 *);
var i   : byte;
    ch  : char;
    h:str6;
Begin
  with K[Kanal]^ do
  Begin
    case RX_bin of
     0 : Begin
           (* normales Textfile *)
           for i := 1 to length(Zeile) do
           Begin
             ch := chr(ord(Zeile[i]) and 127);
             case ch of
              ^I  : write(RXFile,^I);
              ^J  : ;
              ^M  : writeln(RXFile);
              #91 : if Umlaut then write(RXFile,'') else write(RXFile,'[');
              #92 : if Umlaut then write(RXFile,'') else write(RXFile,'\');
              #93 : if Umlaut then write(RXFile,'') else write(RXFile,']');
              #123: if Umlaut then write(RXFile,'') else write(RXFile,'{');
              #124: if Umlaut then write(RXFile,'') else write(RXFile,'|');
              #125: if Umlaut then write(RXFile,'') else write(RXFile,'}');
              #126: if Umlaut then write(RXFile,'') else write(RXFile,'~');
              #127: ;
              #0..#31
                  : Begin
                      write(RXFile,'^');
                      write(RXFile,chr(ord(ch)+64));
                    End;
              else  write(RXFile,ch);
             end;
           End;
         End;
     1,3 : Begin
           (* Automatischer Binrfile-Empfang *)
           write(RXFile,Zeile);
           RX_Count := RX_Count + length(Zeile);
           eigtext:=true; x2:=1;
           h:=int_str(rx_laenge);
           if rx_bin=1 then h:='???' ;
           _aus(kanal,'File-Laenge: '+h+'  empfangen: '+int_str(rx_count));
           if (RX_Count >= RX_Laenge) and  (rx_bin=3) then
           Begin         (* File-Ende ist erreicht, File-Empfang abbrechen ! *)
             StatusOut(Kanal,15,dunkel,copy(space,1,12));
             close(RXFile);
             save := false;
             _aus(Kanal,^M^M + 'Binaerfile-Empfang OK !' + ^M);
           End;
         End;
    end; (* case RX_bin of ... *)

  End; (* with ... do *)
End;


procedure umschichten;
var  aktz: integer; st: string[12];
begin
 aktz:=1;
 with k[show]^ do
  begin
   repeat
    if show > 0 then
      begin
       zeile:=' '+chr(show+48)+' ';
       if connected then zeile:=zeile+call+'  ' else zeile:=zeile+'DISCONNECTED';
      end
    else  zeile:=' MONITOR';
    str(aktz-asl,st);
    zeile:=zeile+copy(space,1,26-length(zeile))+'SCROLL: PgUp PgDn '+#24+' '+
           #25+' End          aktuelle Zeile: '+st+'  ';
    for i:=1 to 80 do
     begin
       bild[videoofs,-1+i*2]:=zeile[i]; bild[videoofs,i*2]:=chr(neg);
     end;
    move(page[(aktz*160)+1],bild[videoofs,161],3840);
    repeat wd:=taste; until (wd>256) OR (wd = 27);
    case wd of
       329: dec(aktz,24);                                        (* PGUP  *)
       337: begin if aktz=1 then wd:=27 else inc(aktz,24); end;  (* PGDM  *)
       328: dec(aktz);                                           (* CURUP *)
       336: begin if aktz=1 then wd:=27 else inc(aktz); end;     (* CURDN *)
       335: wd:=27;                                              (* END   *)
     end;
     if aktz > 1 then aktz:=1;
     if aktz < asl then aktz:=asl;
   until wd=27;
  end;
 zeile:=''; neu_bild;
end;


(*
   Den String 'Zeile' an den Drucker schicken
   Steuerzeichen an den Drucker muessen schon vorher gesendet werden !
*)

procedure write_Drucker (* Kanal : integer ; Zeile : str255 *);
var  i   : integer;
     ch  : char;
Begin
  with K[Kanal]^ do
  Begin
    for i := 1 to length(Zeile) do
    Begin
      ch := chr(ord(Zeile[i]) and 127);
      if (D_Spalte > 80) and (ch <> #13) then
      Begin
        writeln(lst);
        D_Spalte := 1;
      End;
      case ch of
       ^J  : ;
       ^M  : Begin
               if (Kanal = 0) then
               Begin
                 if D_Spalte <> 1 then writeln(lst);
               End
               else writeln(lst);
               D_Spalte := 1;
             End;
       #91 : Begin
               if Umlaut then write(lst,'') else write(lst,'[');
               inc(D_Spalte);
             End;
       #92 : Begin
               if Umlaut then write(lst,'') else write(lst,'\');
               inc(D_Spalte);
             End;
       #93 : Begin
               if Umlaut then write(lst,'') else write(lst,']');
               inc(D_Spalte);
             End;
       #123: Begin
               if Umlaut then write(lst,'') else write(lst,'{');
               inc(D_Spalte);
             End;
       #124: Begin
               if Umlaut then write(lst,'') else write(lst,'|');
               inc(D_Spalte);
             End;
       #125: Begin
               Begin
                 if Umlaut then write(lst,'') else write(lst,'}');
               End;
               inc(D_Spalte);
             End;
       #126: Begin
               Begin
                 if Umlaut then write(lst,'') else write(lst,'~');
               End;
               inc(D_Spalte);
             End;
       #127: ;
       #0..#31
           : ;
       else  Begin
               write(lst,ch);
               inc(D_Spalte);
             End;
      end;
    End;
  End;
End;




(*
   Zeile im Hauptschirm ausgeben
*)

procedure _aus (* Kanal : integer ; Zeile : str255 *);
var i,j       : integer;
    ch        : char;
    Position  : integer;  (* Position im RAM *)
    BildPos   : integer;  (* Position auf dem Schirm *)
    aktuell   : boolean;
    Y_Pos     : integer;
    AMerk     : byte;

Begin

  if (Kanal = show) and not ScreenSTBY then aktuell := true
                                       else aktuell := false;

  with K[Kanal]^ do
  Begin
   if not (save and connected and (not eigtext) and
      ((rx_bin =1) or (rx_bin=3)) ) then begin
     Y_Pos := pred(Trenn);
     BildPos := pred(Y_Pos) * 160 + pred(X2 shl 1);
     Position := 3840 + pred(X2 shl 1);
     for i := 1 to length(Zeile) do
     Begin
       ch := chr(ord(Zeile[i]) and 127);
       umlaute(ch,umlaut);
       case ch of
        ^G  : Begin
                AMerk := TextAttr;
                TextAttr := ctrlAttrib;
                ch := chr(ord(ch)+64);
                if aktuell then
                Begin
                  Bild[VideoOfs,BildPos] := ch;            inc(BildPos);
                  Bild[VideoOfs,BildPos] := chr(TextAttr); inc(BildPos);
                End;
                Page[Position] := ch;            inc(Position);
                Page[Position] := chr(TextAttr); inc(Position);
                inc(X2);
                TextAttr := AMerk;
                if not (save and (RX_bin <> 0)) then
                  if not eigText then
                  Begin
                    j := Pos('-',Call);
                    IF (j = 0) THEN j := Length(Call) else j:=j-1 ;
                    if klingel and Sek30 then begin
                     if Pos(Copy(Call,1,j)+' ',AlarmCalls) <> 0
                        then Triller  else beep(1000,30);
                    End;
                  End;
              End;
        ^J  : ;      (* Ausgabe eines LineFeeds wird immer unterdrueckt *)
        ^M  : Begin
                if (Kanal <> 0) or ((Kanal = 0) and (X2 > 1)) then
                Begin
                  scrollpage(kanal);
  { nur aktuellen kanal bis 1 scrollen, nicht kanal 10, ist video-ram ! }
                  if aktuell then
                  Begin
                    if Kanal = 0 then scrollram(5,25) else scrollram(4,Trenn-1);
                  End;
                  X2 := 1;
                  BildPos := pred(Y_Pos) * 160 + pred(X2 shl 1);
                  Position := 3841;
                End;
              End;
        ^H  : Begin
                if X2 > 1 then
                Begin
                  X2 := pred(X2);
                  Position := pred(pred(Position));
                  BildPos := pred(pred(BildPos));
                End;
              End;
        else  Begin
                AMerk := TextAttr;
                if (ch >= #0) AND (ch <= #31) then
                Begin
                  TextAttr := ctrlAttrib;
                  ch := chr(ord(ch)+64);
                End;
                if aktuell then
                Begin
                  Bild[VideoOfs,BildPos] := ch;            inc(BildPos);
                  Bild[VideoOfs,BildPos] := chr(TextAttr); inc(BildPos);
                End;
                Page[Position] := ch;            inc(Position);
                Page[Position] := chr(TextAttr); inc(Position);
                inc(X2);  TextAttr := AMerk;
              End;
       end; (* case ch of ... *)
       if X2 > 80 then
       Begin
         scrollpage(Kanal);
         if aktuell then
         Begin
           if Kanal = 0 then scrollram(5,25) else scrollram(4,Trenn-1);
         End;
         X2 := 1;
         BildPos := pred(Y_Pos) * 160 + pred(X2 shl 1);
         Position := 3841;
       End;
     End; (* for i := ... *)
   end; (* if not(save and ... *)
    if save and (connected or (Kanal = 0)) then
    Begin
      if RX_bin = 0 then write_SaveFile(Kanal,Zeile)
        else
        Begin
          if not eigText then write_SaveFile(Kanal,Zeile);
        End;
    End;
    if Drucker and (connected or (Kanal = 0)) then write_Drucker(Kanal,Zeile);
    eigText := false;
  End; (* with K[Kanal]^ do *)
End;


(*
   Zeile im Monitorschirm ausgeben
*)

procedure M_aus (* Zeile : str255 *);
var i         : integer;
    ch        : char;
    Position  : integer;  (* Position im RAM *)
    aktuell   : boolean;
    AMerk     : byte;
    Output    : boolean;

Begin

  aktuell := (show = 0);
  Output := (K[show]^.Trenn < 25) OR aktuell;

  with K[0]^ do
  Begin

    Position := 3840 + pred(X2 shl 1);
    for i := 1 to length(Zeile) do
    Begin
      ch := chr(ord(Zeile[i]) and 127);

      umlaute(ch,umlaut);

      if CR then
      Begin
        if not ((ch = #10) OR (ch = #13)) then
        Begin
          CR := false;
          if X2 > 1 then
          Begin
            scrollpage(0);
            if (not ScreenSTBY) and Output then
            Begin
              if aktuell then scrollram(5,25)
                else scrollram(K[show]^.Trenn+1,25);
            End;
            X2 := 1;
            Position := 3841;
          End;
        End;
      End;

      case ch of
       ^J  : ;
       ^M  : Begin
               if Header then CR := true
               else
               Begin
                 scrollpage(0);
                 if (not ScreenSTBY) and Output then
                 Begin
                   if aktuell then scrollram(5,25)
                     else scrollram(K[show]^.Trenn+1,25);
                 End;
                 X2 := 1;
                 Position := 3841;
               End;
             End;
       else  Begin
               AMerk := TextAttr;
               if (ch >= #0) AND (ch <= #31) then
               Begin
                 TextAttr := ctrlAttrib;
                 ch := chr(ord(ch)+64);
               End;
               Page[Position] := ch;
               if (not ScreenSTBY) and Output
                 then Bild[VideoOfs,Position] := ch;
               inc(Position);
               Page[Position] := chr(TextAttr);
               if (not ScreenSTBY) and Output
                 then Bild[VideoOfs,Position] := chr(TextAttr);
               inc(Position);
               inc(X2);
               TextAttr := AMerk;
             End;
      end;

      if X2 > 80 then
      Begin
        scrollpage(0);
        if (not ScreenSTBY) and Output then
        Begin
          if aktuell then scrollram(5,25)
            else scrollram(K[show]^.Trenn+1,25);
        End;
        X2 := 1;
        Position := 3841;
      End;

    End; (* for i := ... *)

    if save then write_SaveFile(0,Zeile);
    if Drucker then write_Drucker(0,Zeile);

  End; (* with K[0]^ do ... *)
End;


(*
   Bis ans Zeilenende loeschen (nur Vorschreibschirm)
*)

procedure _clreol (* Kanal : integer *);
var XMerk   : integer;
Begin
  with K[Kanal]^ do
  Begin
    XMerk := X1;
    while X1 < 80 do V_aus(Kanal,' ');
    X1 := XMerk;
  End;
End;


(*
   Alle Bildspeicher loeschen
   (danach sind die Speicher so aufgebaut wie das Video-RAM)
*)

procedure PageInit;
var Kanal  : integer; i: integer;
Begin
  TextAttr := low;
  clrscr;
  for Kanal := 0 to maxLink do move(Bild[VideoOfs,1],K[Kanal]^.Page[1],4000);
  for kanal := 0 to maxlink do move(bild[videoofs,1],k[kanal]^.line,640);
  for i:=1 to ass do
  for kanal := 0 to maxlink do move(bild[videoofs,1],
                                    k[kanal]^.page[xss+(i-1)*4000],4000);
End;


(*
    Zeichen auf der ersten Statuszeile darstellen
    Syntax:  STATUSOUT(Kanal,X-Position,Attribut,String)
*)

procedure StatusOut (* Kanal,x,Attr:integer ; Zeile:str80 *);
var AMerker   : byte;
Begin
  AMerker := TextAttr;
  case Attr of
   0 : TextAttr := neg;
   1 : TextAttr := neg_fett;
   else if Klingel then write(^G);
  end;
  writePage(Kanal,x,3,Zeile);
  TextAttr := AMerker;
End;


procedure Cursor (* Kanal : integer *);
var   Merk : byte;
Begin
  Merk := TextAttr;
  TextAttr := blink;
  with K[Kanal]^ do
  Begin
    writePage(Kanal,X1,2,'');
    inc(X1);
  End;
  TextAttr := Merk;
End;


END.
