(*
   P R D E F S . P A S
   Variablen-, Typ- und Konstentendeklarationen +
   Initialisierungsroutine fuer alle Variablen
   Wird als UNIT compiliert und ist in allen anderen Units Voraussetzung.
   DL1BHO  11/1988
*)


UNIT PRDefs;

INTERFACE

uses dos;

Const V1_str                  = 'TP V2.6 R3.3 SCROLL'; (* Version *)
      update                  = '04.12.90';            (* letztes Update *)
      inf                     = 'TP-Info: ';              (* fr Remote-msg *)
      weiter                  = 'Weiter mit bel. Taste';  (* fr fenster *)
      space                   = '                                        '+
                                '                                        ';
      LogMerker : string[3]   = '   ';
      ctext     : string[80]  = 'Guten Tag';          (* Connext-Text *)
      disct     : string[80]  = 'Auf Wiedersehen';    (* Disconnect-Text *)

      maxtnc                  = 2;    (* max Anzahl angeschlossener TNC's *)
      maxlink                 = 9;    (* Anzahl der Kanle *)
      cmd_CHAR                = #27;

      hell                    = 1;
      dunkel                  = 0;
      esc                     = #27;
      ass                     = 4 ;            { anzahl zu scrollender seiten }
      xss                     = -(ass*3840)+1; { const fr array in kanalstr }
      asl                     = -(ass*24)+1;   { const fr maxrckzuscroll. Z. }
      qrt       : boolean     = false;     (* Ende-Merker *)

TYPE  str2       = STRING[2];
      str4       = STRING[4];
      str6       = STRING[6];
      str7       = STRING[7];
      str8       = STRING[8];
      str9       = STRING[9];
      str11      = STRING[11];
      str20      = STRING[20];
      str40      = STRING[40];
      Str60      = STRING[60];    (* fr Filenamen *)
      str80      = STRING[80];
      str128     = STRING[128];
      str255     = STRING[255];

      FuenfSTRING = ARRAY[1..5] of STRING[5];

      MH_Typ     = RECORD
                     Call    : STRING[9];   (* Rufzeichen *)
                     Zeit    : STRING[8];   (* zuletzt gehrt um ... *)
                     Tag     : STRING[3];   (* ...am ... *)
                     Info    : WORD;        (* Anzahl Info-Frames *)
                     Via     : STRING[9];   (* Digipeater (Kurzform) *)
                     Link    : STRING[80];  (* ausfhrl. Link *)
                   END;

      RS232Struktur
                 = record
                     TNC          : BOOLEAN;     (* TNC an dieser Schnitte ? *)
                     Ident        : STRING[10];  (* Identifier *)
                     MoniStatus   : STRING[80];  (* Speicher fr den Moni-Status *)
                   end;


      AutoCmdTyp = RECORD
                     Anzahl    : BYTE;
                     cmd_Line  : STRING[255];
                   END;

      KanalStruktur        (* fuer jeden Kanal wird folg. Struktur angelegt: *)
                 = record
                     Call         : str9;        (* Call bei connect *)
                     connected    : BOOLEAN;     (* TRUE wenn connected *)
                     qsoDatum     : STRING[11];  (* Datum QSO-Beginn *)
                     qsoBeginn    : STRING[5];   (* Zeit QSO-Beginn *)
                     qsoEnde      : STRING[5];   (* Zeit QSO-Ende *)
                     ConText      : str80;       (* Text fuers Log *)
                     InputZeile   : STRING[255]; (* Tastatur-EingabeZeile *)
                     cmd          : BOOLEAN;     (* Kommando-Eingabe *)
                     last_cmd     : str80;       (* zuletzt benutztes cmd *)
                     first_Frame  : BOOLEAN;     (* Merker fuer erstes Frame *)
                     X1,X2        : INTEGER;     (* Cursor-Positionen *)
                     line         : Array[1..480] of char; (* 3 zeilen oben,+trennzeile*)
                     Page         : ARRAY[xss..4000] of CHAR; (* BildSpeicher *)
                     Trenn        : INTEGER;     (* Y_Pos der Trennzeile *)
                     Response     : str255;      (* Antwort des TNC *)
                     Response1    : CHAR;        (* fuer 256er Frames *)
                     L_mess       : INTEGER;     (* LinkStatusMessages *)
                     R_Frames     : INTEGER;     (* Received Frames *)
                     S_Frames     : INTEGER;     (* Sent Frames *)
                     T_Frames     : INTEGER;     (* Transmitted Frames *)
                     Tries        : INTEGER;     (* Try-Counter *)
                     LinkState    : INTEGER;     (* Link-Status *)
                     TXFile       : file;        (* Sende-File *)
                     FileSend     : BOOLEAN;     (* Merker fuer FileSend *)
                     TX_Laenge    : LongInt;     (* Laenge von Binaerfiles *)
                     TX_Count     : LongInt;     (* Zaehler f. Bin-Uebertr. *)
                     TX_Buffer    : ARRAY[0..1023] of CHAR;
                     TX_Buffer_Count : INTEGER;
                     TX_bin       : INTEGER;     (* Merker fuer Filesendeart *)
                     RXFile       : text;        (* Save-File mit 1K Buffer *)
                     RXFileBuffer : ARRAY[1..1024] OF CHAR;
                     save         : BOOLEAN;     (* Merker fuer Save *)
                     save_m       : BOOLEAN;
                     save_Name    : Str60;       (* Savefile-Name *)
                     RX_Laenge    : LongInt;     (* nur fr Auto-Binfiles *)
                     RX_Count     : LongInt;
                     RX_bin       : INTEGER;     (* Merker fr Fileempfangsart *)
                     Drucker      : BOOLEAN;     (* Merker fuer Ausdruck *)
                     Umlaut       : BOOLEAN;     (* Umlautwandlung ? *)
                     NR_Stelle    : INTEGER;
                     C_Merker     : Str80;    (* Merker fr Connect und XConnect *)
                     Pause        : INTEGER;
                     Paclen       : INTEGER;     (* Paclen fr diesen Kanal *)
                     MaxFrame     : INTEGER;     (* Maxframe fr diesen Kanal *)
                     poll         : BOOLEAN;     (* soll gepollt werden ? *)
                     RS232        : INTEGER;     (* Nummer der Schnittstelle *)
                     TNCKanal     : CHAR;        (* phys. Kanal des TNCs *)
                     Auto         : BOOLEAN;     (* Digicom-Autom. ein/aus *)
                     Outside      : boolean;     (* Connect kam "von auen" *)
                     Auto_cmd     : BOOLEAN;
                     cmd_Stufe    : INTEGER;
                     cmd_Nummer   : INTEGER;
                     NRPwOK       : BOOLEAN;
                     NochNichtGelesen : BOOLEAN;
                     PassWort     : STRING[4];   (* PW fr DIE BOX ab V1.4 *)
                     merkinput    : str255; (* merker fr letzte inputzeile *)
                     anz_auswert  : byte;    { anzahl der auto-sysop erzeugung}
                     nr_auswert   : byte;    { nr, bei der der richtige kommt }
         { die 2 letzten nur fr sysop, aber je Kanal 2 byte stren net oder? }
                 END;

VAR   Bild       : ARRAY[0..8,1..4096] of CHAR absolute $B000:0;
      K          : ARRAY[0..maxLink] of ^KanalStruktur;
      Kanal      : integer;
      show       : integer;  (* zur Zeit angezeigter Kanal *)
      reg        : registers;
      Sec1Merker,
      Sec10Merker,
      Min1Merker,
      Min10Merker,
      Std1Merker,
      Std10Merker: CHAR;
      LogFile    : text;        (* LogbuchFile   *)
      MFile      : text;        (* Merker - File *)
      AFile      : text;        (* Bildschirm-Attribut-File *)
      Config     : text;
      cmdFile    : text;        (* Init-Befehle fuer die TNCs *)
      NRPWFile   : text;        (* Passwort-File fuer NET/ROM-Remote *)
      Sek30      : BOOLEAN;     (* Programmlaufzeit ueber 30 Sekunden? *)
      Sek30Zaehl : INTEGER;
      Datum      : str11;
      Zeit       : str8;
      ch_out     : CHAR;       (* Zeichen von Tastatur *)
      ch_in      : CHAR;
      NR_Header  : BOOLEAN;
      gesStd     : INTEGER;   (* Gesamt-Programmlaufzeit (Stunden) *)
      gesMin     : INTEGER;   (* Gesamt-Programmlaufzeit (Minuten) *)
      Laufzeit   : INTEGER;   (* Programmlaufzeit seit Prg-Start *)
      VideoCard  : CHAR;
      VideoOfs   : INTEGER;
      i,i1,i2,i3 : INTEGER;   (* Dummy-Variablen *)
      Zeile      : str255;
      PollChannel: INTEGER;
      D_Spalte   : INTEGER;
      Time_stamp : BOOLEAN; (* Merker, Software soll Zeit anfuegen (Moni) *)
      CR         : BOOLEAN;
      MH         : ARRAY[1..maxtnc,1..40] OF MH_Typ;(* MH-Liste fr TNCs  *)
      Schnitte   : ARRAY[1..maxtnc] of RS232Struktur;
      poll_Moni  : INTEGER;
      SendKanal  : INTEGER;
      eigText    : BOOLEAN;
      BaudRate   : INTEGER;
      Drive      : Str60;
      Merk_Drive : Str60;
      SysPfad    : Str60;     (* Pfad fr die Packet-Systemfiles *)
      Pfad_Ueber : INTEGER;
      Printer1   : ARRAY[1..10] of str4;        (* Drucker-Steuerzeichen *)
      Resync_Z   : INTEGER;         (* Zaehler fuer Resync's *)
      AutoCMD    : ARRAY[1..10] OF AutoCmdTyp;
      Nodes_Change : BOOLEAN;       (* Aenderungen in der Nodes-Liste? *)
      active_Port : INTEGER;        (* aktive Schnittstelle *)
      Klingel    : BOOLEAN;
      lastNETROMCall : INTEGER;
      Neu_Bild_if_keypressed : BOOLEAN;
      unproto    : INTEGER;
      TNC_Anzahl : INTEGER;
      multiTNC   : BOOLEAN;
      msg        : ARRAY[1..10,1..255] of CHAR;  (* Festspeichertexte *)
      msgFile    : text;
      Kanal_Anzahl : INTEGER;
      Hardware   : INTEGER;
      ScreenSTBY : BOOLEAN;
      ScreenInit : INTEGER;
      ScreenTimer: INTEGER;
      TextAttrMerk : BYTE;
      MB_remote  : BOOLEAN;
      NR_remote  : BOOLEAN;
      TNC_K      : BOOLEAN; (* im TNC ist K eingeschaltet *)
      TNC_Date   : STRING[11];
      TNC_Time   : STRING[8];
      Ausgabe    : BOOLEAN;
      AlarmCalls : str128;
      Header     : BOOLEAN;
      LPT1_Base  : INTEGER ABSOLUTE 0:$0408;  (* Basisadresse fr LPT1: *)
      LPT1_vorhanden : BOOLEAN;   (* Druckerschnittstelle vorhanden? *)
      Digicom_STRING : STRING;
      HostCall   : str9;
      shell      : str40;
      dateiname  : str60;

      norm,
      low,
      blink,
      neg,
      neg_fett,
      neg_blink,
      ctrlAttrib,
      conRXAttrib,
      conTXAttrib,
      MoniInfoAttrib,
      MoniHeaderAttrib,
      NetzHeaderAttrib     : BYTE;    (* Bildschirm-Attribute *)
      uterr                : str80;    { wenn ut-text zu lang }
      wd                   : word;    (* z.b. fr taste *)

  PROCEDURE Var_Init;


IMPLEMENTATION


  procedure Var_INIT;
  var i    : INTEGER;
  Begin

    for Kanal := 0 to maxLink do
    Begin
      with K[Kanal]^ do
      Begin                   (* Variablen eines jeden Kanals initialisieren *)
        Call :=copy(space,1,9);
        connected := FALSE;
        Outside := true;
        qsoDatum := '';
        qsoBeginn := '';
        qsoEnde := '';
        ConText := '';
        InputZeile := '';
        cmd := FALSE;
        last_cmd := '';
        if Kanal = 0 then Trenn := 26 else Trenn := 19;
        x1 := 1;
        x2 := 1;
        Response := '';
        L_mess := 0;
        R_Frames := 0;
        S_Frames := -1;
        T_Frames := -1;
        Tries := -1;
        if Kanal = 0 then LinkState := 0 else LinkState := -1;
        first_Frame := TRUE;
        RX_bin := 0;
        save := FALSE;
        save_m := FALSE;
        FileSend := FALSE;
        Drucker := FALSE;
        Umlaut := FALSE;
        NR_Stelle := 0;
        C_Merker := '';
        Pause := 1;
        Paclen := 128;
        MaxFrame := 1;
        poll := TRUE;
        RS232 := 0;
        TNCKanal := #0;
        Auto := TRUE;
        Auto_cmd := FALSE;
        cmd_Stufe := 0;
        cmd_Nummer := 1;
        NRPwOK := FALSE;
        NochNichtGelesen := FALSE;
        PassWort := '';
        anz_auswert  := 0;
        nr_auswert   := 0;
      End;
    End;

    LaufZeit := 0;
    PollChannel := 0;
    Sek30 := FALSE;
    Sek30Zaehl := 30;
    NR_Header := FALSE;
    D_Spalte := 1;
    Time_stamp := TRUE;
    CR := FALSE;
    eigText := FALSE;
    Nodes_Change := FALSE;
    active_Port := 99;
    Klingel := TRUE;
    Neu_Bild_if_keypressed := FALSE;
    ScreenSTBY := FALSE;
    MB_remote := FALSE;
    NR_remote := FALSE;
    TNC_K := FALSE;
    Ausgabe := TRUE;
    Pfad_Ueber := 0;
    SysPfad := '';
    Header := TRUE;
    LPT1_vorhanden := (LPT1_Base <> 0);

    fillCHAR(MH,SizeOf(MH),#0);         (* MH-Liste lschen *)

  End;

End.
